#include <linux/module.h>
#include <linux/init.h>
#include <linux/profile.h>

MODULE_LICENSE("GPL");
MODULE_AUTHOR("John Kacur");
MODULE_DESCRIPTION("Very Simple Timer Notification Module");

static int timer_tick(struct pt_regs *regs)
{
	if (printk_ratelimit())
		printk(KERN_ALERT "Received timer tick\n");

	return 0;
}

static int vstnm_init(void)
{
	int rc;
	rc = register_timer_hook(timer_tick);

	if (rc == 0) {
		printk(KERN_ALERT "timer_tick successfully registered\n");
	} else {
		printk(KERN_ALERT "ERROR: could not register timer_tick\n");
	}

	return rc;
}

static void vstnm_exit(void)
{
	unregister_timer_hook(timer_tick);
	printk(KERN_ALERT "timer_tick unregistered\n");
}

module_init(vstnm_init);
module_exit(vstnm_exit);
